diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/wifi/test/power-rate-adaptation-test.cc ns-3.31/src/wifi/test/power-rate-adaptation-test.cc
--- ns-3.30.1/src/wifi/test/power-rate-adaptation-test.cc	2019-08-12 16:30:35.000000000 -0700
+++ ns-3.31/src/wifi/test/power-rate-adaptation-test.cc	2020-06-27 17:38:30.000000000 -0700
@@ -136,6 +136,7 @@
    */
   Mac48Address remoteAddress = Mac48Address::Allocate ();
   WifiMacHeader packetHeader;
+  packetHeader.SetAddr1 (remoteAddress);
   packetHeader.SetType (WIFI_MAC_DATA);
   packetHeader.SetQosTid (0);
   Ptr<Packet> packet = Create<Packet> (10);
@@ -152,7 +153,7 @@
   /*
    * Parf initiates with maximal rate and power.
    */
-  WifiTxVector txVector = manager->GetDataTxVector (remoteAddress, &packetHeader, packet);
+  WifiTxVector txVector = manager->GetDataTxVector (packetHeader);
   WifiMode mode = txVector.GetMode ();
   int power = (int) txVector.GetTxPowerLevel ();
 
@@ -167,10 +168,10 @@
    */
   for (int i = 0; i < 10; i++)
     {
-      manager->ReportDataOk (remoteAddress, &packetHeader, 0, ackMode, 0, packet->GetSize ());
+      manager->ReportDataOk (remoteAddress, &packetHeader, 0, ackMode, 0, txVector, packet->GetSize ());
     }
 
-  txVector = manager->GetDataTxVector (remoteAddress, &packetHeader, packet);
+  txVector = manager->GetDataTxVector (packetHeader);
   mode = txVector.GetMode ();
   power = (int) txVector.GetTxPowerLevel ();
 
@@ -185,7 +186,7 @@
    */
   manager->ReportDataFailed (remoteAddress, &packetHeader, packet->GetSize ());
 
-  txVector = manager->GetDataTxVector (remoteAddress, &packetHeader, packet);
+  txVector = manager->GetDataTxVector (packetHeader);
   mode = txVector.GetMode ();
   power = (int) txVector.GetTxPowerLevel ();
 
@@ -200,12 +201,12 @@
    */
   for (int i = 0; i < 7; i++)
     {
-      manager->ReportDataOk (remoteAddress, &packetHeader, 0, ackMode, 0, packet->GetSize ());
+      manager->ReportDataOk (remoteAddress, &packetHeader, 0, ackMode, 0, txVector, packet->GetSize ());
       manager->ReportDataFailed (remoteAddress, &packetHeader, packet->GetSize ());
     }
-  manager->ReportDataOk (remoteAddress, &packetHeader, 0, ackMode, 0, packet->GetSize ());
+  manager->ReportDataOk (remoteAddress, &packetHeader, 0, ackMode, 0, txVector, packet->GetSize ());
 
-  txVector = manager->GetDataTxVector (remoteAddress, &packetHeader, packet);
+  txVector = manager->GetDataTxVector (packetHeader);
   mode = txVector.GetMode ();
   power = (int) txVector.GetTxPowerLevel ();
 
@@ -220,7 +221,7 @@
 
   manager->ReportDataFailed (remoteAddress, &packetHeader, packet->GetSize ());
 
-  txVector = manager->GetDataTxVector (remoteAddress, &packetHeader, packet);
+  txVector = manager->GetDataTxVector (packetHeader);
   mode = txVector.GetMode ();
   power = (int) txVector.GetTxPowerLevel ();
 
@@ -236,7 +237,7 @@
   manager->ReportDataFailed (remoteAddress, &packetHeader, packet->GetSize ());
   manager->ReportDataFailed (remoteAddress, &packetHeader, packet->GetSize ());
 
-  txVector = manager->GetDataTxVector (remoteAddress, &packetHeader, packet);
+  txVector = manager->GetDataTxVector (packetHeader);
   mode = txVector.GetMode ();
   power = (int) txVector.GetTxPowerLevel ();
 
@@ -251,10 +252,10 @@
    */
   for (int i = 0; i < 10; i++)
     {
-      manager->ReportDataOk (remoteAddress, &packetHeader, 0, ackMode, 0, packet->GetSize ());
+      manager->ReportDataOk (remoteAddress, &packetHeader, 0, ackMode, 0, txVector, packet->GetSize ());
     }
 
-  txVector = manager->GetDataTxVector (remoteAddress, &packetHeader, packet);
+  txVector = manager->GetDataTxVector (packetHeader);
   mode = txVector.GetMode ();
   power = (int) txVector.GetTxPowerLevel ();
 
@@ -269,7 +270,7 @@
 
   manager->ReportDataFailed (remoteAddress, &packetHeader, packet->GetSize ());
 
-  txVector = manager->GetDataTxVector (remoteAddress, &packetHeader, packet);
+  txVector = manager->GetDataTxVector (packetHeader);
   mode = txVector.GetMode ();
   power = (int) txVector.GetTxPowerLevel ();
 
@@ -284,10 +285,10 @@
    */
   for (int i = 0; i < 10; i++)
     {
-      manager->ReportDataOk (remoteAddress, &packetHeader, 0, ackMode, 0, packet->GetSize ());
+      manager->ReportDataOk (remoteAddress, &packetHeader, 0, ackMode, 0, txVector, packet->GetSize ());
     }
 
-  txVector = manager->GetDataTxVector (remoteAddress, &packetHeader, packet);
+  txVector = manager->GetDataTxVector (packetHeader);
   mode = txVector.GetMode ();
   power = (int) txVector.GetTxPowerLevel ();
 
@@ -302,10 +303,10 @@
    */
   for (int i = 0; i < 10; i++)
     {
-      manager->ReportDataOk (remoteAddress, &packetHeader, 0, ackMode, 0, packet->GetSize ());
+      manager->ReportDataOk (remoteAddress, &packetHeader, 0, ackMode, 0, txVector, packet->GetSize ());
     }
 
-  txVector = manager->GetDataTxVector (remoteAddress, &packetHeader, packet);
+  txVector = manager->GetDataTxVector (packetHeader);
   mode = txVector.GetMode ();
   power = (int) txVector.GetTxPowerLevel ();
 
@@ -318,14 +319,14 @@
    * One successful transmissions after a power decrease make recoverPower=false.
    * So we need two consecutive failures to increase power again.
    */
-  manager->ReportDataOk (remoteAddress, &packetHeader, 0, ackMode, 0, packet->GetSize ());
+  manager->ReportDataOk (remoteAddress, &packetHeader, 0, ackMode, 0, txVector, packet->GetSize ());
 
   for (int i = 0; i < 2; i++)
     {
       manager->ReportDataFailed (remoteAddress,&packetHeader, packet->GetSize ());
     }
 
-  txVector = manager->GetDataTxVector (remoteAddress, &packetHeader, packet);
+  txVector = manager->GetDataTxVector (packetHeader);
   mode = txVector.GetMode ();
   power = (int) txVector.GetTxPowerLevel ();
 
@@ -356,6 +357,7 @@
    */
   Mac48Address remoteAddress = Mac48Address::Allocate ();
   WifiMacHeader packetHeader;
+  packetHeader.SetAddr1 (remoteAddress);
   packetHeader.SetType (WIFI_MAC_DATA);
   packetHeader.SetQosTid (0);
   Ptr<Packet> packet = Create<Packet> (10);
@@ -372,7 +374,7 @@
   /*
    * Aparf initiates with maximal rate and power.
    */
-  WifiTxVector txVector = manager->GetDataTxVector (remoteAddress, &packetHeader, packet);
+  WifiTxVector txVector = manager->GetDataTxVector (packetHeader);
   WifiMode mode = txVector.GetMode ();
   int power = (int) txVector.GetTxPowerLevel ();
 
@@ -388,10 +390,10 @@
    */
   for (int i = 0; i < 3; i++)
     {
-      manager->ReportDataOk (remoteAddress, &packetHeader, 0, ackMode, 0, packet->GetSize ());
+      manager->ReportDataOk (remoteAddress, &packetHeader, 0, ackMode, 0, txVector, packet->GetSize ());
     }
 
-  txVector = manager->GetDataTxVector (remoteAddress, &packetHeader, packet);
+  txVector = manager->GetDataTxVector (packetHeader);
   mode = txVector.GetMode ();
   power = (int) txVector.GetTxPowerLevel ();
 
@@ -406,7 +408,7 @@
    */
   manager->ReportDataFailed (remoteAddress, &packetHeader, packet->GetSize ());
 
-  txVector = manager->GetDataTxVector (remoteAddress, &packetHeader, packet);
+  txVector = manager->GetDataTxVector (packetHeader);
   mode = txVector.GetMode ();
   power = (int) txVector.GetTxPowerLevel ();
 
@@ -422,10 +424,10 @@
    */
   for (int i = 0; i < 10; i++)
     {
-      manager->ReportDataOk (remoteAddress, &packetHeader, 0, ackMode, 0, packet->GetSize ());
+      manager->ReportDataOk (remoteAddress, &packetHeader, 0, ackMode, 0, txVector, packet->GetSize ());
     }
 
-  txVector = manager->GetDataTxVector (remoteAddress, &packetHeader, packet);
+  txVector = manager->GetDataTxVector (packetHeader);
   mode = txVector.GetMode ();
   power = (int) txVector.GetTxPowerLevel ();
 
@@ -441,10 +443,10 @@
 
   for (int i = 0; i < 3; i++)
     {
-      manager->ReportDataOk (remoteAddress, &packetHeader, 0, ackMode, 0, packet->GetSize ());
+      manager->ReportDataOk (remoteAddress, &packetHeader, 0, ackMode, 0, txVector, packet->GetSize ());
     }
 
-  txVector = manager->GetDataTxVector (remoteAddress, &packetHeader, packet);
+  txVector = manager->GetDataTxVector (packetHeader);
   mode = txVector.GetMode ();
   power = (int) txVector.GetTxPowerLevel ();
 
@@ -459,10 +461,10 @@
    */
   for (int i = 0; i < 16 * 3; i++)
     {
-      manager->ReportDataOk (remoteAddress, &packetHeader, 0, ackMode, 0, packet->GetSize ());
+      manager->ReportDataOk (remoteAddress, &packetHeader, 0, ackMode, 0, txVector, packet->GetSize ());
     }
 
-  txVector = manager->GetDataTxVector (remoteAddress, &packetHeader, packet);
+  txVector = manager->GetDataTxVector (packetHeader);
   mode = txVector.GetMode ();
   power = (int) txVector.GetTxPowerLevel ();
 
@@ -477,7 +479,7 @@
    */
   manager->ReportDataFailed (remoteAddress,&packetHeader, packet->GetSize ());
 
-  txVector = manager->GetDataTxVector (remoteAddress, &packetHeader, packet);
+  txVector = manager->GetDataTxVector (packetHeader);
   mode = txVector.GetMode ();
   power = (int) txVector.GetTxPowerLevel ();
 
@@ -495,7 +497,7 @@
       manager->ReportDataFailed (remoteAddress,&packetHeader, packet->GetSize ());
     }
 
-  txVector = manager->GetDataTxVector (remoteAddress, &packetHeader, packet);
+  txVector = manager->GetDataTxVector (packetHeader);
   mode = txVector.GetMode ();
   power = (int) txVector.GetTxPowerLevel ();
 
@@ -511,7 +513,7 @@
    */
   manager->ReportDataFailed (remoteAddress,&packetHeader, packet->GetSize ());
 
-  txVector = manager->GetDataTxVector (remoteAddress, &packetHeader, packet);
+  txVector = manager->GetDataTxVector (packetHeader);
   mode = txVector.GetMode ();
   power = (int) txVector.GetTxPowerLevel ();
 
@@ -526,10 +528,10 @@
    */
   for (int i = 0; i < 3; i++)
     {
-      manager->ReportDataOk (remoteAddress, &packetHeader, 0, ackMode, 0, packet->GetSize ());
+      manager->ReportDataOk (remoteAddress, &packetHeader, 0, ackMode, 0, txVector, packet->GetSize ());
     }
 
-  txVector = manager->GetDataTxVector (remoteAddress, &packetHeader, packet);
+  txVector = manager->GetDataTxVector (packetHeader);
   mode = txVector.GetMode ();
   power = (int) txVector.GetTxPowerLevel ();
 
@@ -546,10 +548,10 @@
    */
   for (int i = 0; i < 9 * 3; i++)
     {
-      manager->ReportDataOk (remoteAddress, &packetHeader, 0, ackMode, 0, packet->GetSize ());
+      manager->ReportDataOk (remoteAddress, &packetHeader, 0, ackMode, 0, txVector, packet->GetSize ());
     }
 
-  txVector = manager->GetDataTxVector (remoteAddress, &packetHeader, packet);
+  txVector = manager->GetDataTxVector (packetHeader);
   mode = txVector.GetMode ();
   power = (int) txVector.GetTxPowerLevel ();
 
@@ -558,10 +560,10 @@
 
   for (int i = 0; i < 3; i++)
     {
-      manager->ReportDataOk (remoteAddress, &packetHeader, 0, ackMode, 0, packet->GetSize ());
+      manager->ReportDataOk (remoteAddress, &packetHeader, 0, ackMode, 0, txVector, packet->GetSize ());
     }
 
-  txVector = manager->GetDataTxVector (remoteAddress, &packetHeader, packet);
+  txVector = manager->GetDataTxVector (packetHeader);
   mode = txVector.GetMode ();
   power = (int) txVector.GetTxPowerLevel ();
 
@@ -598,6 +600,7 @@
    */
   Mac48Address remoteAddress = Mac48Address::Allocate ();
   WifiMacHeader packetHeader;
+  packetHeader.SetAddr1 (remoteAddress);
   packetHeader.SetType (WIFI_MAC_DATA);
   packetHeader.SetQosTid (0);
   Ptr<Packet> packet = Create<Packet> (10);
@@ -640,7 +643,7 @@
   /*
    * RRPAA initiates with minimal rate and maximal power.
    */
-  WifiTxVector txVector = manager->GetDataTxVector (remoteAddress, &packetHeader, packet);
+  WifiTxVector txVector = manager->GetDataTxVector (packetHeader);
   WifiMode mode = txVector.GetMode ();
   int power = (int) txVector.GetTxPowerLevel ();
 
@@ -659,10 +662,10 @@
    */
   for (int i = 0; i < 6; i++)
     {
-      manager->ReportDataOk (remoteAddress, &packetHeader, 0, ackMode, 0, packet->GetSize ());
+      manager->ReportDataOk (remoteAddress, &packetHeader, 0, ackMode, 0, txVector, packet->GetSize ());
     }
 
-  txVector = manager->GetDataTxVector (remoteAddress, &packetHeader, packet);
+  txVector = manager->GetDataTxVector (packetHeader);
   mode = txVector.GetMode ();
   power = (int) txVector.GetTxPowerLevel ();
 
@@ -672,9 +675,9 @@
   /**
    * Test that 7 is enough.
    */
-  manager->ReportDataOk (remoteAddress, &packetHeader, 0, ackMode, 0, packet->GetSize ());
+  manager->ReportDataOk (remoteAddress, &packetHeader, 0, ackMode, 0, txVector, packet->GetSize ());
 
-  txVector = manager->GetDataTxVector (remoteAddress, &packetHeader, packet);
+  txVector = manager->GetDataTxVector (packetHeader);
   mode = txVector.GetMode ();
   power = (int) txVector.GetTxPowerLevel ();
 
@@ -692,7 +695,7 @@
       manager->ReportDataFailed (remoteAddress,&packetHeader, packet->GetSize ());
     }
 
-  txVector = manager->GetDataTxVector (remoteAddress, &packetHeader, packet);
+  txVector = manager->GetDataTxVector (packetHeader);
   mode = txVector.GetMode ();
   power = (int) txVector.GetTxPowerLevel ();
 
@@ -701,7 +704,7 @@
 
   manager->ReportDataFailed (remoteAddress,&packetHeader, packet->GetSize ());
 
-  txVector = manager->GetDataTxVector (remoteAddress, &packetHeader, packet);
+  txVector = manager->GetDataTxVector (packetHeader);
   mode = txVector.GetMode ();
   power = (int) txVector.GetTxPowerLevel ();
 
@@ -716,10 +719,10 @@
 
   for (int i = 0; i < 7; i++)
     {
-      manager->ReportDataOk (remoteAddress, &packetHeader, 0, ackMode, 0, packet->GetSize ());
+      manager->ReportDataOk (remoteAddress, &packetHeader, 0, ackMode, 0, txVector, packet->GetSize ());
     }
 
-  txVector = manager->GetDataTxVector (remoteAddress, &packetHeader, packet);
+  txVector = manager->GetDataTxVector (packetHeader);
   mode = txVector.GetMode ();
   power = (int) txVector.GetTxPowerLevel ();
 
@@ -728,10 +731,10 @@
 
   for (int i = 0; i < 10; i++)
     {
-      manager->ReportDataOk (remoteAddress, &packetHeader, 0, ackMode, 0, packet->GetSize ());
+      manager->ReportDataOk (remoteAddress, &packetHeader, 0, ackMode, 0, txVector, packet->GetSize ());
     }
 
-  txVector = manager->GetDataTxVector (remoteAddress, &packetHeader, packet);
+  txVector = manager->GetDataTxVector (packetHeader);
   mode = txVector.GetMode ();
   power = (int) txVector.GetTxPowerLevel ();
 
@@ -740,10 +743,10 @@
 
   for (int i = 0; i < 13; i++)
     {
-      manager->ReportDataOk (remoteAddress, &packetHeader, 0, ackMode, 0, packet->GetSize ());
+      manager->ReportDataOk (remoteAddress, &packetHeader, 0, ackMode, 0, txVector, packet->GetSize ());
     }
 
-  txVector = manager->GetDataTxVector (remoteAddress, &packetHeader, packet);
+  txVector = manager->GetDataTxVector (packetHeader);
   mode = txVector.GetMode ();
   power = (int) txVector.GetTxPowerLevel ();
 
@@ -752,10 +755,10 @@
 
   for (int i = 0; i < 19; i++)
     {
-      manager->ReportDataOk (remoteAddress, &packetHeader, 0, ackMode, 0, packet->GetSize ());
+      manager->ReportDataOk (remoteAddress, &packetHeader, 0, ackMode, 0, txVector, packet->GetSize ());
     }
 
-  txVector = manager->GetDataTxVector (remoteAddress, &packetHeader, packet);
+  txVector = manager->GetDataTxVector (packetHeader);
   mode = txVector.GetMode ();
   power = (int) txVector.GetTxPowerLevel ();
 
@@ -764,10 +767,10 @@
 
   for (int i = 0; i < 23; i++)
     {
-      manager->ReportDataOk (remoteAddress, &packetHeader, 0, ackMode, 0, packet->GetSize ());
+      manager->ReportDataOk (remoteAddress, &packetHeader, 0, ackMode, 0, txVector, packet->GetSize ());
     }
 
-  txVector = manager->GetDataTxVector (remoteAddress, &packetHeader, packet);
+  txVector = manager->GetDataTxVector (packetHeader);
   mode = txVector.GetMode ();
   power = (int) txVector.GetTxPowerLevel ();
 
@@ -776,10 +779,10 @@
 
   for (int i = 0; i < 33; i++)
     {
-      manager->ReportDataOk (remoteAddress, &packetHeader, 0, ackMode, 0, packet->GetSize ());
+      manager->ReportDataOk (remoteAddress, &packetHeader, 0, ackMode, 0, txVector, packet->GetSize ());
     }
 
-  txVector = manager->GetDataTxVector (remoteAddress, &packetHeader, packet);
+  txVector = manager->GetDataTxVector (packetHeader);
   mode = txVector.GetMode ();
   power = (int) txVector.GetTxPowerLevel ();
 
@@ -788,10 +791,10 @@
 
   for (int i = 0; i < 43; i++)
     {
-      manager->ReportDataOk (remoteAddress, &packetHeader, 0, ackMode, 0, packet->GetSize ());
+      manager->ReportDataOk (remoteAddress, &packetHeader, 0, ackMode, 0, txVector, packet->GetSize ());
     }
 
-  txVector = manager->GetDataTxVector (remoteAddress, &packetHeader, packet);
+  txVector = manager->GetDataTxVector (packetHeader);
   mode = txVector.GetMode ();
   power = (int) txVector.GetTxPowerLevel ();
 
@@ -808,19 +811,19 @@
 
   for (int i = 0; i < 49; i++)
     {
-      manager->ReportDataOk (remoteAddress, &packetHeader, 0, ackMode, 0, packet->GetSize ());
+      manager->ReportDataOk (remoteAddress, &packetHeader, 0, ackMode, 0, txVector, packet->GetSize ());
     }
 
-  txVector = manager->GetDataTxVector (remoteAddress, &packetHeader, packet);
+  txVector = manager->GetDataTxVector (packetHeader);
   mode = txVector.GetMode ();
   power = (int) txVector.GetTxPowerLevel ();
 
   NS_TEST_ASSERT_MSG_EQ (mode.GetDataRate (txVector.GetChannelWidth (), txVector.GetGuardInterval (), 1), 54000000, "RRPAA: Incorrect vale of data rate");
   NS_TEST_ASSERT_MSG_EQ (power, 17, "RRPAA: Incorrect value of power level");
 
-  manager->ReportDataOk (remoteAddress, &packetHeader, 0, ackMode, 0, packet->GetSize ());
+  manager->ReportDataOk (remoteAddress, &packetHeader, 0, ackMode, 0, txVector, packet->GetSize ());
 
-  txVector = manager->GetDataTxVector (remoteAddress, &packetHeader, packet);
+  txVector = manager->GetDataTxVector (packetHeader);
   mode = txVector.GetMode ();
   power = (int) txVector.GetTxPowerLevel ();
 
@@ -836,10 +839,10 @@
 
   for (int i = 0; i < 16 * 50; i++)
     {
-      manager->ReportDataOk (remoteAddress, &packetHeader, 0, ackMode, 0, packet->GetSize ());
+      manager->ReportDataOk (remoteAddress, &packetHeader, 0, ackMode, 0, txVector, packet->GetSize ());
     }
 
-  txVector = manager->GetDataTxVector (remoteAddress, &packetHeader, packet);
+  txVector = manager->GetDataTxVector (packetHeader);
   mode = txVector.GetMode ();
   power = (int) txVector.GetTxPowerLevel ();
 
@@ -857,7 +860,7 @@
       manager->ReportDataFailed (remoteAddress,&packetHeader, packet->GetSize ());
     }
 
-  txVector = manager->GetDataTxVector (remoteAddress, &packetHeader, packet);
+  txVector = manager->GetDataTxVector (packetHeader);
   mode = txVector.GetMode ();
   power = (int) txVector.GetTxPowerLevel ();
 
@@ -875,7 +878,7 @@
       manager->ReportDataFailed (remoteAddress,&packetHeader, packet->GetSize ());
     }
 
-  txVector = manager->GetDataTxVector (remoteAddress, &packetHeader, packet);
+  txVector = manager->GetDataTxVector (packetHeader);
   mode = txVector.GetMode ();
   power = (int) txVector.GetTxPowerLevel ();
 
@@ -893,7 +896,7 @@
       manager->ReportDataFailed (remoteAddress,&packetHeader, packet->GetSize ());
     }
 
-  txVector = manager->GetDataTxVector (remoteAddress, &packetHeader, packet);
+  txVector = manager->GetDataTxVector (packetHeader);
   mode = txVector.GetMode ();
   power = (int) txVector.GetTxPowerLevel ();
 
@@ -909,7 +912,7 @@
       manager->ReportDataFailed (remoteAddress,&packetHeader, packet->GetSize ());
     }
 
-  txVector = manager->GetDataTxVector (remoteAddress, &packetHeader, packet);
+  txVector = manager->GetDataTxVector (packetHeader);
   mode = txVector.GetMode ();
   power = (int) txVector.GetTxPowerLevel ();
 
@@ -926,10 +929,10 @@
 
   for (int i = 0; i < 25; i++)
     {
-      manager->ReportDataOk (remoteAddress, &packetHeader, 0, ackMode, 0, packet->GetSize ());
+      manager->ReportDataOk (remoteAddress, &packetHeader, 0, ackMode, 0, txVector, packet->GetSize ());
     }
 
-  txVector = manager->GetDataTxVector (remoteAddress, &packetHeader, packet);
+  txVector = manager->GetDataTxVector (packetHeader);
   mode = txVector.GetMode ();
   power = (int) txVector.GetTxPowerLevel ();
 
@@ -941,7 +944,7 @@
       manager->ReportDataFailed (remoteAddress,&packetHeader, packet->GetSize ());
     }
 
-  txVector = manager->GetDataTxVector (remoteAddress, &packetHeader, packet);
+  txVector = manager->GetDataTxVector (packetHeader);
   mode = txVector.GetMode ();
   power = (int) txVector.GetTxPowerLevel ();
 
@@ -953,7 +956,7 @@
       manager->ReportDataFailed (remoteAddress,&packetHeader, packet->GetSize ());
     }
 
-  txVector = manager->GetDataTxVector (remoteAddress, &packetHeader, packet);
+  txVector = manager->GetDataTxVector (packetHeader);
   mode = txVector.GetMode ();
   power = (int) txVector.GetTxPowerLevel ();
 
@@ -962,10 +965,10 @@
 
   for (int i = 0; i < 25; i++)
     {
-      manager->ReportDataOk (remoteAddress, &packetHeader, 0, ackMode, 0, packet->GetSize ());
+      manager->ReportDataOk (remoteAddress, &packetHeader, 0, ackMode, 0, txVector, packet->GetSize ());
     }
 
-  txVector = manager->GetDataTxVector (remoteAddress, &packetHeader, packet);
+  txVector = manager->GetDataTxVector (packetHeader);
   mode = txVector.GetMode ();
   power = (int) txVector.GetTxPowerLevel ();
 
@@ -982,7 +985,7 @@
     {
       for (int j = 0; j < 25; j++)
         {
-          manager->ReportDataOk (remoteAddress, &packetHeader, 0, ackMode, 0, packet->GetSize ());
+          manager->ReportDataOk (remoteAddress, &packetHeader, 0, ackMode, 0, txVector, packet->GetSize ());
         }
 
       for (int j = 0; j < 5; j++)
@@ -991,7 +994,7 @@
         }
     }
 
-  txVector = manager->GetDataTxVector (remoteAddress, &packetHeader, packet);
+  txVector = manager->GetDataTxVector (packetHeader);
   mode = txVector.GetMode ();
   power = (int) txVector.GetTxPowerLevel ();
 
@@ -1027,7 +1030,7 @@
 };
 
 PowerRateAdaptationTestSuite::PowerRateAdaptationTestSuite ()
-  : TestSuite ("power-rate-adaptation-wifi", UNIT)
+  : TestSuite ("wifi-power-rate-adaptation", UNIT)
 {
   AddTestCase (new PowerRateAdaptationTest, TestCase::QUICK);
 }
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/wifi/test/spectrum-wifi-phy-test.cc ns-3.31/src/wifi/test/spectrum-wifi-phy-test.cc
--- ns-3.30.1/src/wifi/test/spectrum-wifi-phy-test.cc	2019-08-12 16:30:35.000000000 -0700
+++ ns-3.31/src/wifi/test/spectrum-wifi-phy-test.cc	2020-06-27 17:38:30.000000000 -0700
@@ -23,12 +23,11 @@
 #include "ns3/spectrum-wifi-phy.h"
 #include "ns3/nist-error-rate-model.h"
 #include "ns3/wifi-mac-header.h"
-#include "ns3/wifi-mac-trailer.h"
-#include "ns3/wifi-phy-tag.h"
 #include "ns3/wifi-spectrum-signal-parameters.h"
 #include "ns3/wifi-phy-listener.h"
 #include "ns3/log.h"
-#include "ns3/wifi-phy-header.h"
+#include "ns3/wifi-psdu.h"
+#include "ns3/wifi-ppdu.h"
 
 using namespace ns3;
 
@@ -73,17 +72,17 @@
   void SendSignal (double txPowerWatts);
   /**
    * Spectrum wifi receive success function
-   * \param p the packet
+   * \param psdu the PSDU
    * \param snr the SNR
    * \param txVector the transmit vector
    * \param statusPerMpdu reception status per MPDU
    */
-  void SpectrumWifiPhyRxSuccess (Ptr<Packet> p, double snr, WifiTxVector txVector, std::vector<bool> statusPerMpdu);
+  void SpectrumWifiPhyRxSuccess (Ptr<WifiPsdu> psdu, double snr, WifiTxVector txVector, std::vector<bool> statusPerMpdu);
   /**
    * Spectrum wifi receive failure function
-   * \param p the packet
+   * \param psdu the PSDU
 -   */
-  void SpectrumWifiPhyRxFailure (Ptr<Packet> p);
+  void SpectrumWifiPhyRxFailure (Ptr<WifiPsdu> psdu);
   uint32_t m_count; ///< count
 
 private:
@@ -106,33 +105,26 @@
 Ptr<SpectrumSignalParameters>
 SpectrumWifiPhyBasicTest::MakeSignal (double txPowerWatts)
 {
-  WifiTxVector txVector = WifiTxVector (WifiPhy::GetOfdmRate6Mbps (), 0, WIFI_PREAMBLE_LONG, false, 1, 1, 0, 20, false, false);
+  WifiTxVector txVector = WifiTxVector (WifiPhy::GetOfdmRate6Mbps (), 0, WIFI_PREAMBLE_LONG, 800, 1, 1, 0, 20, false, false);
 
   Ptr<Packet> pkt = Create<Packet> (1000);
   WifiMacHeader hdr;
-  WifiMacTrailer trailer;
 
   hdr.SetType (WIFI_MAC_QOSDATA);
   hdr.SetQosTid (0);
-  uint32_t size = pkt->GetSize () + hdr.GetSize () + trailer.GetSerializedSize ();
-  Time txDuration = m_phy->CalculateTxDuration (size, txVector, m_phy->GetFrequency ());
-  hdr.SetDuration (txDuration);
 
-  pkt->AddHeader (hdr);
-  pkt->AddTrailer (trailer);
+  Ptr<WifiPsdu> psdu = Create<WifiPsdu> (pkt, hdr);
+  Time txDuration = m_phy->CalculateTxDuration (psdu->GetSize (), txVector, m_phy->GetFrequency ());
 
-  LSigHeader sig;
-  pkt->AddHeader (sig);
-
-  WifiPhyTag tag (txVector.GetPreambleType (), txVector.GetMode ().GetModulationClass (), 1);
-  pkt->AddPacketTag (tag);
+  Ptr<WifiPpdu> ppdu = Create<WifiPpdu> (psdu, txVector, txDuration, FREQUENCY);
 
   Ptr<SpectrumValue> txPowerSpectrum = WifiSpectrumValueHelper::CreateOfdmTxPowerSpectralDensity (FREQUENCY, CHANNEL_WIDTH, txPowerWatts, GUARD_WIDTH);
   Ptr<WifiSpectrumSignalParameters> txParams = Create<WifiSpectrumSignalParameters> ();
   txParams->psd = txPowerSpectrum;
   txParams->txPhy = 0;
   txParams->duration = txDuration;
-  txParams->packet = pkt;
+  txParams->ppdu = ppdu;
+
   return txParams;
 }
 
@@ -144,16 +136,16 @@
 }
 
 void
-SpectrumWifiPhyBasicTest::SpectrumWifiPhyRxSuccess (Ptr<Packet> p, double snr, WifiTxVector txVector, std::vector<bool> statusPerMpdu)
+SpectrumWifiPhyBasicTest::SpectrumWifiPhyRxSuccess (Ptr<WifiPsdu> psdu, double snr, WifiTxVector txVector, std::vector<bool> statusPerMpdu)
 {
-  NS_LOG_FUNCTION (this << p << snr << txVector);
+  NS_LOG_FUNCTION (this << *psdu << snr << txVector);
   m_count++;
 }
 
 void
-SpectrumWifiPhyBasicTest::SpectrumWifiPhyRxFailure (Ptr<Packet> p)
+SpectrumWifiPhyBasicTest::SpectrumWifiPhyRxFailure (Ptr<WifiPsdu> psdu)
 {
-  NS_LOG_FUNCTION (this << p);
+  NS_LOG_FUNCTION (this << *psdu);
   m_count++;
 }
 
@@ -305,9 +297,9 @@
   Simulator::Run ();
 
   NS_TEST_ASSERT_MSG_EQ (m_count, 1, "Didn't receive right number of packets");
+  NS_TEST_ASSERT_MSG_EQ (m_listener->m_notifyMaybeCcaBusyStart, 2, "Didn't receive NotifyMaybeCcaBusyStart (preamble deteted + L-SIG received)");
   NS_TEST_ASSERT_MSG_EQ (m_listener->m_notifyRxStart, 1, "Didn't receive NotifyRxStart");
   NS_TEST_ASSERT_MSG_EQ (m_listener->m_notifyRxEndOk, 1, "Didn't receive NotifyRxEnd");
-  NS_TEST_ASSERT_MSG_EQ (m_listener->m_notifyMaybeCcaBusyStart, 0, "Received NotifyMaybeCcaBusyStart unexpectedly");
 
   Simulator::Destroy ();
   delete m_listener;
@@ -326,7 +318,7 @@
 };
 
 SpectrumWifiPhyTestSuite::SpectrumWifiPhyTestSuite ()
-  : TestSuite ("spectrum-wifi-phy", UNIT)
+  : TestSuite ("wifi-spectrum-wifi-phy", UNIT)
 {
   AddTestCase (new SpectrumWifiPhyBasicTest, TestCase::QUICK);
   AddTestCase (new SpectrumWifiPhyListenerTest, TestCase::QUICK);
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/wifi/test/tx-duration-test.cc ns-3.31/src/wifi/test/tx-duration-test.cc
--- ns-3.30.1/src/wifi/test/tx-duration-test.cc	2019-08-12 16:30:35.000000000 -0700
+++ ns-3.31/src/wifi/test/tx-duration-test.cc	2020-06-27 17:38:30.000000000 -0700
@@ -49,7 +49,7 @@
    * Check if the payload tx duration returned by InterferenceHelper
    * corresponds to a known value of the pay
    *
-   * @param size size of payload in octets (includes everything after the PLCP header)
+   * @param size size of payload in octets (includes everything after the PHY header)
    * @param payloadMode the WifiMode used for the transmission
    * @param channelWidth the channel width used for the transmission (in MHz)
    * @param guardInterval the guard interval duration used for the transmission (in nanoseconds)
@@ -64,7 +64,7 @@
    * Check if the overall tx duration returned by InterferenceHelper
    * corresponds to a known value of the pay
    *
-   * @param size size of payload in octets (includes everything after the PLCP header)
+   * @param size size of payload in octets (includes everything after the PHY header)
    * @param payloadMode the WifiMode used for the transmission
    * @param channelWidth the channel width used for the transmission (in MHz)
    * @param guardInterval the guard interval duration used for the transmission (in nanoseconds)
@@ -212,7 +212,7 @@
 
   NS_TEST_EXPECT_MSG_EQ (retval, true, "an 802.11b CCK duration failed");
 
-  //Similar, but we add PLCP preamble and header durations
+  //Similar, but we add PHY preamble and header durations
   //and we test different rates.
   //The payload durations for modes other than 11mbb have been
   //calculated by hand according to  IEEE Std 802.11-2007 18.2.3.5
@@ -439,7 +439,7 @@
 };
 
 TxDurationTestSuite::TxDurationTestSuite ()
-  : TestSuite ("devices-wifi-tx-duration", UNIT)
+  : TestSuite ("wifi-devices-tx-duration", UNIT)
 {
   AddTestCase (new TxDurationTest, TestCase::QUICK);
 }
